import smartpy as sp
from smartpy.templates.chess import main, play, build_fen

if "main" in __name__:
    player1 = sp.test_account("player1")
    player2 = sp.test_account("player2")

    @sp.add_test()
    def test():
        sc = sp.test_scenario("Chess - Vachier Lagrave Maxime vs Bacrot Etienne")
        c1 = main.Chess(player1.address, player2.address)

        sc.h1("Vachier Lagrave,M (2579) vs. Bacrot,E (2705) 1/2-1/2")
        sc += c1

        # Vachier Lagrave,M (2579) vs. Bacrot,E (2705) 1/2-1/2
        c1.play(play(f=sp.record(i=1, j=4), t=sp.record(i=3, j=4)), _sender=player1)
        c1.play(play(f=sp.record(i=6, j=4), t=sp.record(i=4, j=4)), _sender=player2)
        c1.play(play(f=sp.record(i=0, j=6), t=sp.record(i=2, j=5)), _sender=player1)
        c1.play(play(f=sp.record(i=7, j=1), t=sp.record(i=5, j=2)), _sender=player2)
        c1.play(play(f=sp.record(i=0, j=5), t=sp.record(i=4, j=1)), _sender=player1)
        c1.play(play(f=sp.record(i=6, j=0), t=sp.record(i=5, j=0)), _sender=player2)
        c1.play(play(f=sp.record(i=4, j=1), t=sp.record(i=5, j=2)), _sender=player1)
        c1.play(play(f=sp.record(i=6, j=3), t=sp.record(i=5, j=2)), _sender=player2)
        c1.play(play(f=sp.record(i=0, j=4), t=sp.record(i=0, j=6)), _sender=player1)
        sc.verify(
            build_fen(c1)
            == "r1bqkbnr/1pp2ppp/p1p5/4p3/4P3/5N2/PPPP1PPP/RNBQ1RK1 b kq - 1 5"
        )
        c1.play(play(f=sp.record(i=6, j=5), t=sp.record(i=5, j=5)), _sender=player2)
        c1.play(play(f=sp.record(i=1, j=3), t=sp.record(i=3, j=3)), _sender=player1)
        c1.play(play(f=sp.record(i=4, j=4), t=sp.record(i=3, j=3)), _sender=player2)
        c1.play(play(f=sp.record(i=2, j=5), t=sp.record(i=3, j=3)), _sender=player1)
        c1.play(play(f=sp.record(i=5, j=2), t=sp.record(i=4, j=2)), _sender=player2)
        c1.play(play(f=sp.record(i=3, j=3), t=sp.record(i=2, j=1)), _sender=player1)
        c1.play(play(f=sp.record(i=7, j=3), t=sp.record(i=0, j=3)), _sender=player2)
        c1.play(play(f=sp.record(i=0, j=5), t=sp.record(i=0, j=3)), _sender=player1)
        c1.play(play(f=sp.record(i=7, j=2), t=sp.record(i=3, j=6)), _sender=player2)
        c1.play(play(f=sp.record(i=1, j=5), t=sp.record(i=2, j=5)), _sender=player1)
        c1.play(play(f=sp.record(i=3, j=6), t=sp.record(i=6, j=3)), _sender=player2)
        c1.play(play(f=sp.record(i=0, j=1), t=sp.record(i=2, j=2)), _sender=player1)
        c1.play(play(f=sp.record(i=7, j=4), t=sp.record(i=7, j=2)), _sender=player2)
        c1.play(play(f=sp.record(i=0, j=2), t=sp.record(i=3, j=5)), _sender=player1)
        c1.play(play(f=sp.record(i=4, j=2), t=sp.record(i=3, j=2)), _sender=player2)
        c1.play(play(f=sp.record(i=2, j=1), t=sp.record(i=4, j=0)), _sender=player1)
        c1.play(play(f=sp.record(i=7, j=5), t=sp.record(i=4, j=2)), _sender=player2)
        c1.play(play(f=sp.record(i=0, j=6), t=sp.record(i=0, j=5)), _sender=player1)
        c1.play(play(f=sp.record(i=6, j=1), t=sp.record(i=4, j=1)), _sender=player2)
        c1.play(play(f=sp.record(i=1, j=0), t=sp.record(i=3, j=0)), _sender=player1)
        c1.play(play(f=sp.record(i=7, j=6), t=sp.record(i=6, j=4)), _sender=player2)
        sc.verify(
            build_fen(c1)
            == "2kr3r/2pbn1pp/p4p2/Npb5/P1p1PB2/2N2P2/1PP3PP/R2R1K2 w - - 1 16"
        )
        c1.play(play(f=sp.record(i=3, j=0), t=sp.record(i=4, j=1)), _sender=player1)
        c1.play(play(f=sp.record(i=6, j=3), t=sp.record(i=4, j=1)), _sender=player2)
        c1.play(play(f=sp.record(i=3, j=5), t=sp.record(i=1, j=3)), _sender=player1)
        c1.play(play(f=sp.record(i=7, j=7), t=sp.record(i=7, j=4)), _sender=player2)
        c1.play(play(f=sp.record(i=2, j=2), t=sp.record(i=4, j=1)), _sender=player1)
        c1.play(play(f=sp.record(i=5, j=0), t=sp.record(i=4, j=1)), _sender=player2)
        c1.play(play(f=sp.record(i=1, j=1), t=sp.record(i=2, j=1)), _sender=player1)
        c1.play(play(f=sp.record(i=3, j=2), t=sp.record(i=2, j=1)), _sender=player2)
        c1.play(play(f=sp.record(i=4, j=0), t=sp.record(i=2, j=1)), _sender=player1)
        c1.play(play(f=sp.record(i=4, j=2), t=sp.record(i=5, j=1)), _sender=player2)
        c1.play(play(f=sp.record(i=1, j=3), t=sp.record(i=2, j=2)), _sender=player1)
        c1.play(play(f=sp.record(i=7, j=3), t=sp.record(i=0, j=3)), _sender=player2)
        c1.play(play(f=sp.record(i=0, j=0), t=sp.record(i=0, j=3)), _sender=player1)
        c1.play(play(f=sp.record(i=6, j=2), t=sp.record(i=4, j=2)), _sender=player2)
        c1.play(play(f=sp.record(i=0, j=3), t=sp.record(i=5, j=3)), _sender=player1)
        c1.play(play(f=sp.record(i=5, j=1), t=sp.record(i=6, j=0)), _sender=player2)
        c1.play(play(f=sp.record(i=5, j=3), t=sp.record(i=5, j=0)), _sender=player1)
        c1.play(play(f=sp.record(i=7, j=2), t=sp.record(i=6, j=1)), _sender=player2)
        c1.play(play(f=sp.record(i=5, j=0), t=sp.record(i=5, j=4)), _sender=player1)
        c1.play(play(f=sp.record(i=6, j=1), t=sp.record(i=6, j=2)), _sender=player2)
        c1.play(play(f=sp.record(i=3, j=4), t=sp.record(i=4, j=4)), _sender=player1)
        c1.play(play(f=sp.record(i=6, j=2), t=sp.record(i=6, j=3)), _sender=player2)
        c1.play(play(f=sp.record(i=5, j=4), t=sp.record(i=5, j=0)), _sender=player1)
        c1.play(play(f=sp.record(i=6, j=4), t=sp.record(i=7, j=2)), _sender=player2)
        c1.play(play(f=sp.record(i=4, j=4), t=sp.record(i=5, j=5)), _sender=player1)
        c1.play(play(f=sp.record(i=6, j=6), t=sp.record(i=5, j=5)), _sender=player2)
        c1.play(play(f=sp.record(i=5, j=0), t=sp.record(i=5, j=5)), _sender=player1)
        c1.play(play(f=sp.record(i=7, j=2), t=sp.record(i=5, j=3)), _sender=player2)
        c1.play(play(f=sp.record(i=5, j=5), t=sp.record(i=5, j=7)), _sender=player1)
        c1.play(play(f=sp.record(i=7, j=4), t=sp.record(i=6, j=4)), _sender=player2)
        c1.play(play(f=sp.record(i=5, j=7), t=sp.record(i=4, j=7)), _sender=player1)
        c1.play(play(f=sp.record(i=6, j=3), t=sp.record(i=5, j=2)), _sender=player2)
        c1.play(play(f=sp.record(i=2, j=2), t=sp.record(i=0, j=4)), _sender=player1)
        c1.play(play(f=sp.record(i=5, j=3), t=sp.record(i=3, j=2)), _sender=player2)
        c1.play(play(f=sp.record(i=0, j=4), t=sp.record(i=1, j=5)), _sender=player1)
        c1.play(play(f=sp.record(i=3, j=2), t=sp.record(i=2, j=4)), _sender=player2)
        c1.play(play(f=sp.record(i=1, j=5), t=sp.record(i=2, j=4)), _sender=player1)
        c1.play(play(f=sp.record(i=6, j=4), t=sp.record(i=2, j=4)), _sender=player2)
        c1.play(play(f=sp.record(i=4, j=7), t=sp.record(i=6, j=7)), _sender=player1)
        c1.play(play(f=sp.record(i=6, j=0), t=sp.record(i=5, j=1)), _sender=player2)
        c1.play(play(f=sp.record(i=6, j=7), t=sp.record(i=5, j=7)), _sender=player1)
        c1.play(play(f=sp.record(i=5, j=2), t=sp.record(i=6, j=2)), _sender=player2)
        c1.play(play(f=sp.record(i=5, j=7), t=sp.record(i=6, j=7)), _sender=player1)
        c1.play(play(f=sp.record(i=6, j=2), t=sp.record(i=5, j=2)), _sender=player2)
        c1.play(play(f=sp.record(i=6, j=7), t=sp.record(i=5, j=7)), _sender=player1)
        c1.play(play(f=sp.record(i=5, j=2), t=sp.record(i=6, j=2)), _sender=player2)
        c1.play(play(f=sp.record(i=5, j=7), t=sp.record(i=6, j=7)), _sender=player1)
        c1.play(play(f=sp.record(i=6, j=2), t=sp.record(i=5, j=2)), _sender=player2)
        c1.play(play(f=sp.record(i=6, j=7), t=sp.record(i=5, j=7)), _sender=player1)

        sc.verify(build_fen(c1) == "8/8/1bk4R/1pp5/8/1N2rP2/2P3PP/5K2 b - - 10 40")
